<template>
  <v-row no-gutters>
    <v-col cols="12">
      <v-row no-gutters>
        <v-col cols="7" align="start">
          <v-text-field
            v-model="plate"
            label="Placa"
            outlined
            dense
            @change="updateVehicleDetails"
          />
          <v-row no-gutters>
            <v-col cols="4">
              <v-select
                v-model="driverIdType"
                class="mr-2"
                :items="IdTypes"
                label="Tipo de documento"
                outlined
                dense
                @change="updateVehicleDetails"
              />
            </v-col>
            <v-col cols="8">
              <v-text-field
                v-model="driverIdNumber"
                label="Número documento de conductor"
                outlined
                dense
                @change="updateVehicleDetails"
              />
            </v-col>
          </v-row>
        </v-col>
        <v-col cols="5" align="end">
          <v-btn
            :href="toGoogleMaps"
            target="_blank"
            color="primary"
            outlined
            @click="toStore"
          >
            <v-icon left>
              mdi-map
            </v-icon>
            Ruta Generada
          </v-btn>
        </v-col>
      </v-row>
      <v-row no-gutters>
        <v-col cols="12">
          <vehicle-detail-orders
            :vehicle-id="details.id"
            :order-ids="orderIds"
          />
        </v-col>
      </v-row>
    </v-col>
  </v-row>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import { compose, join, map } from 'ramda';
import VehicleDetailOrders from './VehicleDetailOrders';
import IdTypes, { DNI } from '~/services/company/id-type';
import { errorOptions, successOptions } from '~/helpers/toast';

export default {
  name: 'VehicleDetails',
  components: {
    VehicleDetailOrders,
  },
  props: {
    details: {
      type: Object,
      default: () => ({}),
    },
    id: {
      type: [Number, String],
      required: true,
    },
  },
  data() {
    const { plate } = this.details.vehicle ?? {};
    const { documentNumber, documentType } = this.details.driver ?? {};
    return {
      IdTypes,
      plate: plate ?? '',
      driverIdType: documentType ?? DNI,
      driverIdNumber: documentNumber ?? '',
    };
  },
  computed: {
    ...mapState({
      dispatch: state => state.programming.dispatches.current.dispatch,
      baseUrl: state => state.programming.dispatches.baseUrl,
      centerLocation: state => state.programming.dispatches.current.center.location,
    }),
    orderIds() {
      return this.details.orderIdsToDispatch ?? [];
    },
    uri() {
      const locations = this.details.routeLocations;
      const formatLocation = ({ latitude, longitude }) => `/${latitude},${longitude}`;
      const routeLocations = [this.centerLocation, ...locations, this.centerLocation];
      return compose(join(''), map(formatLocation))(routeLocations);
    },
    toGoogleMaps() {
      return this.baseUrl + this.uri;
    },
  },
  methods: {
    ...mapActions({
      storeRoutes: 'programming/dispatches/storeRoutes',
      updateVehicleAndDriver: 'programming/dispatches/updateVehicleAndDriver',
    }),
    toStore() {
      this.storeRoutes({ vehicleId: this.id, uri: this.uri });
    },
    async updateVehicleDetails() {
      try {
        const vehicleId = this.details.id;
        const plate = this.plate;
        const dispatchId = this.dispatch.id;
        const driver = { type: this.driverIdType, number: this.driverIdNumber };
        await this.updateVehicleAndDriver({ dispatchId, vehicleId, data: { plate, driver } });
        this.$toast.success('Se han actualizado los datos del vehículo programado', successOptions);
      } catch (e) {
        this.$toast.error('No se ha podido actualizar los datos del vehículo programado', errorOptions);
      }
    },
  },
};
</script>
